local SERVER_ID = 1       -- 服务器标识
local MAX_CLIENT = 8000   -- 最大连接数限制

local GAME_PORT = 8010    -- 向客户开放的游戏端口
local WEB_PORT = 9010     -- 向WEB开放的控制端口
local CONSOLE_PORT = 7010 -- 控制台端口

local REDIS_HOST = "127.0.0.1"    -- 数据库主机ip地址
local REDIS_PORT = 6010               -- 数据库端口
local REDIS_AUTH = 'xh123'          -- 数据库密码

local WEB_HOST = "0.0.0.0"

option = {
  sid = SERVER_ID,
  game_port = GAME_PORT,
  web_port = WEB_PORT,
  console_port = CONSOLE_PORT,
  max_client = MAX_CLIENT,
  web_host = WEB_HOST,
  redis = {
    auth = REDIS_AUTH,
    host = REDIS_HOST,
    port = REDIS_PORT,
  },
  cluster_redis = {
    auth = REDIS_AUTH,
    host = REDIS_HOST,
    port = 7000,
  },
  cluster = {
    -- log = "127.0.0.1:2345",
  }
}

-- 集群地址配置
-- CLUSTER = {
--   watchdog = "127.0.0.1:10001", -- 接受集群推送
--   master = "127.0.0.1:12000",
-- }

-- 集群启动使用参数
-- MASTER_CONF = {
--   debug_port = 5558,
--   web_port = 5559,
-- }

-- 服务器启动相关参数
LAUNCH = {
  test_recharge = true;       -- 测试充值
  maintain = false,           -- true:维护 false:开放
  battle_log = true,         -- true:开启战斗日志 false:关闭战斗日志
  white_list = {
  },
}

RECHARGE_SERVICE = "127.0.0.1:8081"
