require "host"    -- import host config

STD_ERR = require "errno"

MAXRAND = 10000

DAY_SEC = 86400
HOUR_SEC = 3600
MIN_SEC = 60

MONEY_PARAM = 100 

-- 物品类型
GOODS_NONE      = 0 -- 未知类型
GOODS_HERO      = 1 -- 英雄(角色)
GOODS_CARD      = 2 -- 技能卡
GOODS_EQUIP     = 3 -- 装备
GOODS_MONEY     = 4 -- 货币
GOODS_DEBRIS    = 5 -- 碎片
GOODS_BOX       = 6 -- 宝箱

-- 定义全局货币id, 根据GoodsConfig修改
CURRENCY_ID_COINS           = 100001        -- 金币
CURRENCY_ID_STM             = 110001        -- 体力
CURRENCY_ID_DIA             = 130001        -- 钻石
CURRENCY_ID_ROLE_EXP        = 140001        -- 队伍经验
CURRENCY_ID_EXP_STONE       = 140002        -- 经验石
CURRENCY_ID_TALENT_STONE    = 140003        -- 天赋石


-- CURRENCY_ID_DACTIVITY   = 110003        -- 日常活跃
-- CURRENCY_ID_WACTIVITY   = 110004        -- 周常活跃
-- CURRENCY_ID_RELIC_SCORE = 110005        -- 遗迹积分
-- CURRENCY_ID_RELIC_COIN  = 110006        -- 遗迹币
-- CURRENCY_ID_EQUIP_COIN  = 110009        -- 锻造锤
-- CURRENCY_ID_DIA         = 130001        -- 钻石
-- CURRENCY_ID_IRON        = 140001        -- 铁矿
-- CURRENCY_ID_WOOD        = 140002        -- 铁矿
-- CURRENCY_ID_ROLE_EXP    = 140003        -- 队伍经验
-- CURRENCY_ID_EXP_STONE   = 140004        -- 经验石
-- CURRENCY_ID_EXP_BOOK    = 140005        -- 经验书
-- CURRENCY_ID_TALENT_STONE    = 140006        -- 天赋石
-- CURRENCY_ID_WEAPON_SCROLL   = 140007        -- 武器卷轴
-- CURRENCY_ID_JEWELRY_SCROLL  = 140008        -- 首饰卷轴
-- CURRENCY_ID_WRISTER_SCROLL  = 140009        -- 护腕卷轴
-- CURRENCY_ID_CUIRASS_SCROLL  = 140010        -- 胸甲卷轴
-- CURRENCY_ID_BELT_SCROLL = 140011        -- 腰带卷轴
-- CURRENCY_ID_SHOE_SCROLL = 140012        -- 鞋子卷轴G
-- CURRENCY_ID_DRAW_COIN   = 140050        -- 召唤卷
-- CURRENCY_ID_DRAW_COIN2 = 140051        -- 高级召唤卷


-- 货币类型
CURRENCY_TYPE_RANDOM_BOX = 8    -- 随机宝箱
CURRENCY_TYPE_SELECT_BOX = 9    -- 选择宝箱

-- 英雄类型
HERO_TYPE_CARD= 5
HERO_TYPE_CITY = 6

-- 品阶
STAR_COLOR_PURPLE = 4   -- 紫色
STAR_COLOR_ORANGE = 7   -- 橙色
STAR_COLOR_RED = 11     -- 红色

-- 任务类型
DAILY_QUEST     = 1     -- 日常任务
WEEKLY_QUEST    = 2     -- 周常任务
ACHI_QUEST      = 3     -- 成就任务
MAIN_QUEST    = 4 -- 主线任务

-- 任务状态
QUEST_PROGRESS  = 0     -- 进行中的任务
QUEST_REACHED   = 1     -- 已达成的任务
QUEST_END       = 2     -- 已结束的任务

-- 排行榜类型
RANKING_ADV = 1         -- 冒险
RANKING_POWER = 2       -- 战力

-- 支付方式
PAY_TYPE_FREE = 0    -- 免费
PAY_TYPE_GIFT = 1    -- 计费点礼包
PAY_TYPE_ITEM = 2    -- 资源支付

-- 限购方式
LIMIT_TYPE_NONE = 0     -- 不限购
LIMIT_TYPE_DAILY = 1    -- 日限购
LIMIT_TYPE_WEEKLY = 2   -- 周限购
LIMIT_TYPE_MONTHLY = 3   -- 月限购
LIMIT_TYPE_LONG = 4     -- 终身限购


-- 不知到放哪就放这把
OTHER_REDIS_KEY = "other"


STATE_OPEN = 0 -- 活动开启
STATE_CLOSE = 1 -- 活动关闭
STATE_OVER = 2 -- 活动结束(奖励领取结束,或不再显示)

-- 模块id
MODULE_ID_RELIC_MANUA = 50

-- 活动相关模块
MODULE_ID_QUEST = 15        -- 任务
MODULE_ID_SIGN_IN = 18      -- 日常签到
MODULE_ID_DIA_DRAW = 20     -- 抽卡
MODULE_ID_SHOP = 45         -- 商店
MODULE_ID_DAILY_DUNGEONS = 53 -- 日常副本
MODULE_ID_FUND = 61         -- 基金
MODULE_ID_LOTTERY = 76      -- 千抽     

MODULE_ID_RELIC = 2003      -- 遗迹
MODULE_ID_DRAW_EQUIP = 2004  -- 装备锻造
MODULE_ID_DIA_SHOP = 2009
MODULE_ID_ADV_GIFT = 2010   -- 冒险礼包
MODULE_ID_PRIVILEGE_CARD = 2011 -- 特权卡
MODULE_ID_AD_CARD = 2012
MODULE_ID_MONTH_CARD = 2013     -- 月卡
MODULE_ID_SUPREME_CARD = 2014
MODULE_ID_KEEP_RECHARGE = 2015 -- 连续充值
MODULE_ID_LEVEL_GIFT = 2017 -- 等级礼包

MODULE_ID_FIRST_RECHARGE1 = 54
MODULE_ID_FIRST_RECHARGE2 = 3002
MODULE_ID_FIRST_RECHARGE3 = 3003

MODULE_ID_FUND1 = 3006 -- 成长基金
MODULE_ID_FUND2 = 3007 -- 冒险基金
MODULE_ID_FUND3 = 3008 -- 精英基金
MODULE_ID_FUND4 = 3009 -- 召唤基金
MODULE_ID_FUND5 = 3010 -- 锻造基金

MODULE_ID_POP_GIFT = 3011 -- 弹窗礼包

MODULE_ID_HERO_RANK = 4001          -- 开服英雄排行
MODULE_ID_SIMPLE_BATTLE_RANK = 4002 -- 开服闯关排行
MODULE_ID_POWER_RANK = 4003         -- 开服战力排行
MODULE_ID_ELITE_BATTLE_RANK = 4004  -- 开服精英排行
MODULE_ID_TREASURE = 4005   -- 开服宝藏


--怪物类型
MONESTER_TYPE_ORDINARGY = 21 -- 普通
MONESTER_TYPE_ELITE = 22    -- 精英
MONESTER_TYPE_BOSS = 23     -- boss

--
ATTR_ADV_COIN = 100     -- 冒险金币加成
ATTR_ADV_EXP_STONE = 101      -- 冒险经验石加成
ATTR_FARM_ADD = 102     -- 农场加成
ATTR_COIN_ADD = 103     -- 金矿加成
ATTR_WOOD_ADD = 104     -- 伐木场加成
ATTR_IRON_ADD = 105     -- 铁矿加成

-- 品质（装备/道具）
-- eQUALITY = {
--   WHITE   = 0,    -- 白
--   GREEN   = 1,    -- 绿
--   BLUE    = 2,    -- 蓝
--   PURPLE  = 3,    -- 紫
--   ORANGE  = 4,    -- 橙
--   RED	  = 5,    -- 红
--   DRED    = 6,    -- 深红
--   GOLDEN  = 7,    -- 金
--   DGOLDEN = 8,    -- 升金
-- }




-- 聊天类型 主类型
-- CHAT_TYPE = {
--     WORD_CHAT       = 1,          -- 世界聊天
--     NOTICE_CHAT     = 2,          -- 公告
--     PRIVATE_CHAT    = 3,          -- 私聊
--     GUILD_CHAT      = 4,          -- 公会聊天
--     SPAN_CHAT       = 5,          -- 跨服聊天
-- }



-- -- 公告子类型
-- CHAT_SON_TYPE = {
--     VIP_UP = 101,                 -- 跑马灯配置sid-玩家vip提升
--     RED_ELF = 201,                -- 跑马灯配置sid-玩家获得红色精灵
--     ORANGE_ELF = 202,             -- 跑马灯配置sid-玩家获得橙色精灵
--     GOLDEN_ELF = 203,             -- 跑马灯配置sid-玩家获得金色精灵
--     GEM_UP = 301,                 -- 跑马灯配置sid-宝石升级6级以上
--     STAR_UP = 401,                -- 跑马灯配置sid-精灵升星6星以上
--     GM_NOTICE = 501,              -- 跑马灯配置sid-来自ＧＭ的系统公告
--     SPELUNK_1 = 701,              -- 地心第一名
--     SPELUNK_2 = 702,              -- 地心第二名
--     SPELUNK_3 = 703,              -- 地心第三名
--     PROTABLE  = 801,              -- 携带拍三个以上
--     BUDO_ID = 901,                -- 道馆通关
--     ELF_KING = 1100,              -- 精灵王胜利
--     ELF_AWAKEN = 1201,            -- 精灵觉醒
--     ELF_UPANISHADS = 1301,        -- 精灵学习奥义
--     WORLD_BOSS  = 1508,           -- 世界boss被击败
--     RUNE_GET = 1509,              -- 玩家获得橙色(及)以上的符文
--     UP_WORLD_BOSS = 1514,         -- 世界boss刷新
--     BT_EASY=1510,                 --通关埋藏之塔普通
--     BT_DIFFICULT=1511,            --通关埋藏之塔困难
--     ADVENTURE_FIRST=1512,         --首位通关章节地图
--     SE_RED=1513,                  --完成红色秘境任务
--     BADGE_INFO=1601,              --徽章升级到指定数量
--     DRESS_TITLE=1701,             --获得时装获得称号
--     DIAMOND_WEEK=2201,            --购买周卡
--     DIAMOND_MONTH=2202,            --购买月卡
--     DIAMOND_LIFELONG=2203,         --购买终身卡
--     FUND_BUY=2204,                 --购买成长基金
--     MEGA_REDGET=1801,              --通关mega副本获得红色钥石
--     AWAKEN_PLAYER=2001,            --角色进阶达到高阶训练家以上
--     RUNE_STRENGTH=2101,            --符文强化
--     MAZE_FIVE=2205,                --宝可梦迷宫通关第五层
--     Z_ACTIVE=2301,                 --怒气技能激活
--     Z_UPGRADE=2302,                 --怒气技能升级
--     FIRSTL_ATHLETICSMOD=2401,       --冠军之路第一名
--     FIRSTL_ALONE_BATTLE=2402,       --单挑之王第一名
--     HANG_GET_RED_EQUIP=2501,        --挂机获得红装
--     SMELT_GET_RED_EQUIP=2502,       --熔炼获得红装
--     MAKE_GET_RED_EQUIP=2503,        --打造获得红装
--     HANG_GET_RED_DEVRIS=2504,       --挂机获得红色精灵碎片

--     NEWHUNTING_BOSS=2698,       --新狩猎boss触发


--     -- s_type
--     GUILD_CHAT       = 600,       -- 公会玩家聊天
--     GUILD_jx1        = 601,       -- 公会捐献钻石
--     GUILD_jx2        = 602,       -- 公会捐献金币
--     GUILD_UP_LV      = 603,       -- 公会升级
--     GUILD_ADV_AUTO   = 604,       -- 公会自动开启冒险
--     GUILD_ADV_HAND   = 605,       -- 公会成员开启冒险
--     GUILD_ADV_FINISH = 606,       -- 完成冒险地图
--     GUILD_ADV_UNLOCK = 607,       -- 解锁新的冒险地图
--     GUILD_JION       = 608,       -- 玩家加入公会
--     GUILD_EXIT       = 609,       -- 玩家离开公会
--     GUILD_DUTY       = 610,       -- 玩家职务变更
--     GUILD_APPLY_FAIL = 611,       -- 公会战报名，分配据点失败 报名公会过多
--     GUILD_APPLY_SUC  = 612,       -- 公会战报名，分配据点成功
-- }
