--facebook
local skynet = require "skynet"
local httpc = require "http.httpc"
local logger = require "logger"
local cjson = require "cjson"
local stringify = require "stringify"
local md5 = require "md5"
require "skynet.manager"

local trace = logger.trace
local cjson_decode = cjson.decode

local cdkconf = {
  host = "https://oauth2.googleapis.com",
  url = "/tokeninfo?id_token=%s",
  ["gameloft_infinite"] = { -- 智乐互娱 海外包
    forbidden = false,          -- 是否开放
    ["com.xjl3.www"] = {},        -- google包
    ["com.xjl3ios.www"] ={},     -- ios
    ['com.xjl3ios.appname'] = {}, -- 智乐互娱 IOS A2
    ['com.fantasticios.appname'] = {}, -- 智乐互娱 IOS A3
    ['com.xjl3.appname'] = {}, -- 智乐互娱 google A5
  },
  ["wydh_ft"] = {               -- 微赢互动 繁体包
    forbidden = false,          -- 是否开放
    ["com.wyyx.fzxls"] = {},    -- google
    ["com.lzl.fzxlsft"] = {},   -- IOS
    ["com.cxjjwk.pkq"] = {},    -- google
  },
  ["wyhd_ft_bt"] = {          -- ft bt
    forbidden = false,
    ['com.rain.mhlc'] = {},
  },
}

local google = {}

function google.login_player(args)
    local channel = args.channel
    if not cdkconf[channel] then
      logger.trace("### google 不存在的渠道 %s", channel)
      return
    end
    if cdkconf[channel].forbidden then
      logger.trace("### google 渠道登陆关闭 %s",channel)
      return
    end
    local channel_info = cdkconf[channel][args.appid]
    logger.error("google 登陆请求 appid:%s,channel:%s",args.appid,channel)
    -- if not channel_info or not channel_info.appid or not channel_info.appkey then
    if not channel_info  then
      logger.trace("google登录失败 错误的渠道信息")
        return
    end

    local info = string.format(cdkconf.url, args.token)
    logger.trace("google login start %s",info)
    local ok, ret, body = pcall(httpc.get,cdkconf.host,info)
    logger.trace("google login end %s",args.channel)
    if ok then
      logger.trace("google回馈:%s",body)
      local resp = cjson_decode(body) or {}
      if resp.iss and resp.exp then
        return 0
      else
        logger.trace("google登录验证失败body:%s", body)
        return
      end
    else
      logger.trace("google登录验证 ret:%s", ret)
      return
    end
    logger.trace("google登录验证 info2:%s", info)
    return
end

function google.login_test()
  local ret = google.login_player({
    channel = "gameloft_infinite_and",      -- 渠道名
    appid = "com.xjl3.www",                 -- 包名
    token = "ajfdalsjf",                   -- SDK 返回密钥
  })
  if ret then
    logger.trace(" ### 登陆成功")
  else
    logger.trace(" ### 登陆失败")
  end
end

return google