local skynet = require "skynet"
require "skynet.manager"
local cjson = require "cjson"
local logger = require "logger"
local stringify = require "stringify"
local sha2 = require "sha2"
local sha256 = sha2.sha256

local trace = logger.trace
local warn = logger.warn
local shengtian = require "service.loginserver.shengtian"

local SDK = {}
SDK.shengtian = shengtian.login_player

local CMD = {}
function CMD.start(conf)
  logger.info("start")

--   skynet.fork(function()
--     skynet.sleep(500)
--     logger.trace(" #### 登陆测试 #### ")
--     shengtian.login_test()
--   end)
end

function CMD.login(args)
    if args.channel == "" then
        return 0
    end
    trace("login request:\n%s", stringify(args))

    local k = args.channel or ""
    if string.len(k) == 0 then
        warn("invalid channel identifier")
        return
    end

    local auth = SDK[k]
    if auth == nil then
        warn("channel [%s]: unrealized", k)
        return
    end
    return auth(args)
end

skynet.init(function()
  skynet.register(".loginserver")
end)

skynet.start(function()
  local skynet_retpack = skynet.retpack
  logger.label("<Login server>,")

	skynet.dispatch("lua", function(session, source, cmd, ...)
    local f = assert(CMD[cmd], cmd)
    if session == 0 then
      f(...)
    else
      skynet_retpack(f(...))
    end
	end)
end)
